<template>
	<view class="u-avatar" :style="[wrapStyle]" @tap="click">
		<image @error="loadError" :style="[imgStyle]" class="u-avatar-img" v-if="!text && defaultAvatar" :src="defaultAvatar" :mode="imgMode"></image>
		<text class="u-line-1" v-else-if="text">{{text}}</text>
		<slot v-else></slot>
	</view>
</template>

<script>
	/**
	 * alertTips 提示
	 * @description 该组件一般的图片裁剪需求场景，尤其适合于头像裁剪方面。
	 * @tutorial https://www.uviewui.com/components/avatarCropper.html
	 * @property {String Number} dest-width 输出图片宽度，高等于宽，单位px（默认200）
	 * @property {String Number} rect-width 裁剪框宽度，高等于宽，单位px（默认200）
	 * @property {String} file-type 输出的图片类型，如果'png'类型发现裁剪的图片太大，改成"jpg"即可（默认jpg）
	 * @event {Function} uAvatarCropper 裁剪结束后的事件，通过uni.$on监听
	 * @example <image class="u-avatar-demo" :src="avatar" mode="aspectFill"></image>
	 */
	let base64Avatar = "data:image/png;base64,[encoded data, 10396 characters]";
	export default {
		props: {
			// 背景颜色
			bgColor: {
				type: String,
				default: 'transparent'
			},
			// 头像路径
			src: {
				type: String,
				default: ''
			},
			// 尺寸，large-大，default-中等，mini-小，如果为数值，则单位为rpx
			// 宽度等于高度
			size: {
				type: [String, Number],
				default: 'default'
			},
			// 头像模型，square-带圆角方形，circle-圆形
			mode: {
				type: String,
				default: 'circle'
			},
			// 文字内容
			text: {
				type: String,
				default: ''
			},
			// 图片的裁剪模型
			imgMode: {
				type: String,
				default: 'aspectFill'
			},
			// 标识符
			index: {
				type: [String, Number],
				default: ''
			}
		},
		data() {
			return {
				error: false,
			}
		},
		computed: {
			wrapStyle() {
				let style = {};
				style.height = this.size == 'large' ? '120rpx' : this.size == 'default' ? 
				'90rpx' : this.size == 'mini' ? '70rpx' : this.size + 'rpx';
				style.width = style.height;
				style.flex = `0 0 ${style.height}`;
				style.backgroundColor = this.bgColor;
				style.borderRadius = this.mode == 'circle' ? '500px' : '5px';
				if(this.text) style.padding = `0 6rpx`;
				return style;
			},
			defaultAvatar() {
				if(!this.src) return base64Avatar;
				else if(this.src && this.error) return base64Avatar;
				else return this.src;
			},
			imgStyle() {
				let style = {};
				style.borderRadius = this.mode == 'circle' ? '500px' : '5px';
				return style;
			}
		},
		methods: {
			// 图片加载错误时，显示默认头像
			loadError() {
				this.error = true;
			},
			click() {
				this.$emit('click', this.index);
			}
		}
	}
</script>

<style lang="scss" scoped>
	.u-avatar {
		display: inline-flex;
		align-items: center;
		justify-content: center;
		font-size: 28rpx;
		color: $u-content-color;
		border-radius: 10px;
		overflow: hidden; 
	}
	
	.u-avatar-img {
		width: 100%;
		height: 100%;
	}
</style>
